#/usr/bin/gawk -f
#Hilfsprogramm fr Reichelt-Sammelbestellung.
#Jeder Teilnehmer der Sammelbestellung erstellt einen Warenkorb bei
#www.reichelt.de und druckt diesen auf den Drucker "Universal/Nur Text"
#im Querformat(!) aus. Danach Zusendung der entstehenden .PRN-Datei
#an den Sammelbesteller (ggf. mit Vorauszahlung).
#Die Dateinamen sollten dem Login-Krzel des Bestellers entsprechen!

#Dieses Skript erkennt Mehrfachbestellungen identischer Artikel
#und teilt die (Versand-)Kosten nach Bestellwert auf die Endkunden auf.

#Rabatte werden nicht erkannt! Deshalb nur bedingt fr Conrad einsetzbar.
#(Das geht auch schlecht, bruchte man doch fr jeden Artikel die Staffelung.)
#Warengruppen-Rabatt wird noch nicht verarbeitet.
#Besteller von schweren Artikeln werden noch nicht bestraft.

#Aufruf:
#gawk -f merge.awk *.prn
#oder (nach Ankunft des Pakets)
#gawk -f merge.awk Alles=123.45 *.prn
#(Gesamtsumme einsetzen)
#Nicht gelieferte Artikel aus den *.prn-Dateien streichen!

#Dem Sammelbesteller bleibt es leider nicht erspart, die Bestellpositionen
#von Hand noch mal ins Webformular einzugeben...

BEGIN{
# Feldbreiten fr:
# Bestellnummer
# Bestellbezeichnung
# Warengruppe
# Stckzahl
# Einzelpreis
# Euro
# Gesamtpreis
# Euro
#  FIELDWIDTHS="20 55 2 7 13 2 13 2";
 IGNORECASE=1;
 MWSt=1.19;
#Versandkosten (Kilogramm:Euro)
 Versandk="10:5.6 10:11.2 30:16.8 40:22.4 50:28";
}

/per Bankeinzug/ {
 Masse=$5;	# in kg
 sub(/,/,".",Masse);
 Masse+=0;
 Kunde=FILENAME;
 sub(/.prn/,"",Kunde);
 Massen[Kunde]=Masse;
 Gesamtmasse+=Masse;
 next;
}

function SetLength(idx,string,len) {
 len=length(string);
 if (width[idx]<len) width[idx]=len;
}

#jede brige Zeile:
/\x80.+\x80/{
#Zeile auslesen
 i=substr($0,1,20);
 sub(/ +$/,"",i);
 Bezeich=substr($0,21,55);
 sub(/ +$/,"",Bezeich);
 Anzahl=substr($0,78,7)+0;
 Preis=substr($0,85,13);
 sub(/,/,".",Preis);
 Preis+=0;
 Kunde=FILENAME;
 sub(/.prn/,"",Kunde);
#Felder fllen 
 Beschr[i]=Bezeich;
 EPreis[i]=Preis;
# Wareng[$1] = $3;
 Stueck[i]+=Anzahl;
 if (Kunden[i]) Kunden[i]=Kunden[i] SUBSEP Kunde ":" Anzahl;
 else Kunden[i]=Kunde ":" Anzahl;
}

END{
#Notwendige Spaltenbreiten ermitteln
 for (i in Stueck) {
  SetLength(1,i);
  SetLength(2,Beschr[i]);
  SetLength(3,Stueck[i]);
  SetLength(4,sprintf("%.2f",EPreis[i]));
  SetLength(5,sprintf("%.2f",EPreis[i]*Stueck[i]));
 }
 for (i in Stueck) {
  printf("%-*s  %-*s  %*i  %*.2f  %*.2f",
   width[1],i,width[2],Beschr[i],width[3],Stueck[i],
   width[4],EPreis[i],width[5],Stueck[i]*EPreis[i]);
  n=split(Kunden[i],a,SUBSEP);
  if (n==1) {
   split(a[1],k,":");
   printf("  %s\n",k[1]);
  }else{
   print;
   for (j=1; j<=n; j++) {
    split(a[j],k,":");
    anz=k[2]+0;
    printf("%*i%*.2f  %s\n",
      width[1]+width[2]+width[3]+4,anz,
      width[4]+width[5]+4,EPreis[i]*anz,
      k[1]);
   }
  }
  for (j=1; j<=n; j++) {
   split(a[j],k,":");
   Summe[k[1]]+=EPreis[i]*k[2];
  }
 }
 print;
 SetLength(6,"Kunde");
 SetLength(7,"brutto");
 for (i in Summe) {
  SetLength(6,i);
  SetLength(7,sprintf("%.2f",Summe[i]));
  Brutto+=Summe[i];
 }
 if (!Alles) {
  n=split(Versandk,a," ");
  for (j=1; j<n; j++) {
   split(a[j],k,":");
   vk=k[2];
   if (k[1]>Gesamtmasse) break;
  }
  Alles=Brutto*1.005+vk;	#Transportversicherung, Versandkosten
 }
 
 printf("%-*s   Masse  %*s  %*s  zu bezahlen\n",
   width[6],"Kunde",
   width[7],"netto",
   width[7],"brutto");
 
 for (i in Summe) {
  printf("%-*s  %6.3f  %*.2f  %*.2f  %*.2f\n",
    width[6],i,
    Massen[i],
    width[7],Summe[i]/MWSt,
    width[7],Summe[i],
    width[7],Summe[i]*Alles/Brutto);
 }
 printf("alles  %*.3f  %*.2f  %*.2f  %*.2f\n",
   width[6]+1,Gesamtmasse,
   width[7],Brutto/MWSt,
   width[7],Brutto,
   width[7],Alles);
}
